package farm;


import farm.Milkable;
import farm.Living;
import fi.helsinki.cs.tmc.edutestutils.Points;
import fi.helsinki.cs.tmc.edutestutils.ReflectionUtils;
import fi.helsinki.cs.tmc.edutestutils.Reflex;
import fi.helsinki.cs.tmc.edutestutils.Reflex.ClassRef;
import fi.helsinki.cs.tmc.edutestutils.Reflex.MethodRef0;
import fi.helsinki.cs.tmc.edutestutils.Reflex.MethodRef1;
import java.lang.reflect.Field;
import java.util.ArrayList; 
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import org.junit.Assert;
import static org.junit.Assert.*;
import org.junit.Test;

public class FarmSimulatorTest<S, L, R, N, M> {

    private ClassRef<S> MilkContainerClassRef;
    private MethodRef0<S, Double> MilkContainerGetcapacityMethodRef;
    private MethodRef0<S, Double> MilkContainerGetmilkAvailableMethodRef;
    private MethodRef0<S, Double> MilkContainerPaljonkoTilaaJaljellaMethodRef;
    private MethodRef1<S, Void, Double> MilkContaineraddMilkMethodRef;
    private MethodRef1<S, Double, Double> MilkContainertakeMilkMethodRef;
    private ClassRef<L> CowClassRef;
    private MethodRef0<L, String> CowGetNimiMethodRef;
    private MethodRef0<L, Double> CowGetcapacityMethodRef;
    private MethodRef0<L, Double> CowGetamountMethodRef;
    private MethodRef0<L, Double> CowLypsaMethodRef;
    private MethodRef0<L, Void> CowEleleTuntiMethodRef;
    private ClassRef<R> MilkingRobotClassRef;
    private MethodRef1<R, Void, Milkable> MilkingRobotLypsaMethodRef;
    private MethodRef1<R, Void, S> MilkingRobotSetMilkContainerMethodRef;
    private MethodRef0<R, S> MilkingRobotGetMilkContainerMethodRef;
    private ClassRef<N> BarnClassRef;
    private MethodRef0<N, S> BarnGetMilkContainerMethodRef;
    private MethodRef1<N, Void, R> BarninstallMilkingRobotMethodRef;
    private MethodRef1<N, Void, L> BarnHoidaCowMethodRef;
    private MethodRef1<N, Void, List> BarnHoidaCowsMethodRef;
    private ClassRef<M> farmClassRef;
    private MethodRef0<M, String> farmGetOmistajaMethodRef;
    private MethodRef1<M, Void, R> farminstallBarnMilkingRobotMethodRef;
    private MethodRef1<M, Void, L> farmLisaaCowMethodRef;
    private MethodRef0<M, Void> farmHoidaCowsMethodRef;
    private MethodRef0<M, Void> farmEleleTuntiMethodRef;

    public static void testIfInteger(Class<?> Class,
            String methodName, double luku, String returnValue) {
        if (!Double.valueOf(luku).equals(Math.ceil(luku))) {
            Assert.fail("The class's " + Class.getName() + " methods "
                    + methodName + " return value " + luku
                    + " should be round using the Math-class's ceil()-method. "
                    + "The current return value: " + returnValue);
        }
    }

    @Test
    @Points("10-14.1")
    public void testMilkContainer() throws Throwable {
        reflektoiMilkContainer();

        S container = createMilkContainer(MilkContainerClassRef, null);

        String v = ""
                + "MilkContainer m = new MilkContainer();";

        testCapacity(container, 2000.0, v);
        testMilkAvaible(container, 0.0, v);
        testCapacityLeft(container, v);

        v = ""
                + "MilkContainer m = new MilkContainer();\n"
                + "m.addMilk(20.234);";

        testAddMilk(container, 20.234, v);

        v = ""
                + "MilkContainer m = new MilkContainer();\n"
                + "m.addMilk(20.234);\n"
                + "m.addMilk(2032.0);";

        testAddMilk(container, 2032.0, v);

        v = ""
                + "MilkContainer m = new MilkContainer();\n"
                + "m.addMilk(20.234);\n"
                + "m.addMilk(2032.0);\n"
                + "m.addMilk(5000.0);";

        testAddMilk(container, 5000.0, v);

        container = createMilkContainer(MilkContainerClassRef, 5782.4);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);";

        testCapacity(container, 5782.4, v);
        testMilkAvaible(container, 0.0, v);
        testCapacityLeft(container, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);";

        testAddMilk(container, 3232.13, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);\n"
                + "m.addMilk(50000.99);\n";

        testAddMilk(container, 50000.99, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);\n"
                + "m.addMilk(50000.99);\n"
                + "m.addMilk(5000.0);";

        testAddMilk(container, 5000.0, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);\n"
                + "m.addMilk(50000.99);\n"
                + "m.addMilk(5000.0);\n"
                + "m.takeMilk(1.5);";

        testTakeMilk(container, 1.5, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);\n"
                + "m.addMilk(50000.99);\n"
                + "m.addMilk(5000.0);\n"
                + "m.takeMilk(1.5);\n"
                + "m.takeMilk(1432.1232);";

        testTakeMilk(container, 1432.1232, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);\n"
                + "m.addMilk(50000.99);\n"
                + "m.addMilk(5000.0);\n"
                + "m.takeMilk(1.5);\n"
                + "m.takeMilk(1432.1232);\n"
                + "m.takeMilk(50000.0)";

        testTakeMilk(container, 50000.0, v);

        v = ""
                + "MilkContainer m = new MilkContainer(5782.4);\n"
                + "m.addMilk(3232.13);\n"
                + "m.addMilk(50000.99);\n"
                + "m.addMilk(5000.0);\n"
                + "m.takeMilk(1.5);\n"
                + "m.takeMilk(1432.1232);\n"
                + "m.takeMilk(50000.0)\n"
                + "m.takeMilk(50000.0)";

        testTakeMilk(container, 50000.0, v);
    }

    @Test
    @Points("10-14.2")
    public void testCow() throws Throwable {
        reflektoiCow();

        L Cow = createCow(CowClassRef, null);

        String v = "Cow Cow = new Cow();";

        testCowLiving(Cow, v);
        testCowMilking(Cow, v);

        testCowLiving(Cow, v);
        testCowLiving(Cow, v);

        testCowMilking(Cow, v);
        testCowMilking(Cow, v);

        for (int i = 0; i < 300; i++) {
            testCowLiving(Cow, v);
        }

        testCowMilking(Cow, v);
    }

    @Test
    @Points("10-14.3")
    public void testMilkingRobot() throws Throwable {
        reflektoiMilkContainer();
        reflektoiCow();
        reflektoiMilkingRobot();

        R robo = createMilkingRobot(MilkingRobotClassRef);
        L Cow = createCow(CowClassRef, null);

        testCowLiving(Cow);

        S container = createMilkContainer(MilkContainerClassRef, 100.0);

        String v = "MilkingRobot r = new MilkingRobot();\n"
                + "MilkContainer m = new MilkContainer(100.0);\n"
                + "r.setMilkContainer(m);";

        MilkingRobotSetMilkContainerMethodRef.withNiceError(v).invokeOn(robo, container);

        testCowLiving(Cow);
        testCowLiving(Cow);

        testMilkingRobotMilking(robo, Cow);
    }

    @Test
    @Points("10-14.3")
    public void testMilkingRobotWithoutContainer() throws Throwable {
        reflektoiMilkContainer();
        reflektoiCow();
        reflektoiMilkingRobot();

        R robo = createMilkingRobot(MilkingRobotClassRef);
        L Cow = createCow(CowClassRef, null);

        testMilkingRobotMilkingWithoutContainer(robo, Cow);
    }

    /*
     *
     */
    @Test
    @Points("10-14.4")
    public void testBarn() throws Throwable {
        reflektoiMilkContainer();
        reflektoiCow();
        reflektoiMilkingRobot();
        reflektoiBarn();

        L Cow1 = createCow(CowClassRef, "Cow1");
        L Cow2 = createCow(CowClassRef, "Cow2");
        L Cow3 = createCow(CowClassRef, "Cow3");
        L Cow4 = createCow(CowClassRef, "Cow4");

        testCowLiving(Cow1);
        testCowLiving(Cow1);
        testCowLiving(Cow1);
        testCowLiving(Cow1);
        testCowLiving(Cow1);
        testCowLiving(Cow2);
        testCowLiving(Cow2);
        testCowLiving(Cow2);
        testCowLiving(Cow2);
        testCowLiving(Cow3);
        testCowLiving(Cow3);

        List<L> Cows = new ArrayList<L>();
        Cows.add(Cow1);
        Cows.add(Cow2);
        Cows.add(Cow3);
        Cows.add(Cow4);

        S container = createMilkContainer(MilkContainerClassRef, 8374.0);

        N Barn = createBarn(BarnClassRef, container);

        R robo = createMilkingRobot(MilkingRobotClassRef);

        try {
            BarninstallMilkingRobotMethodRef.invokeOn(Barn, robo);
        } catch (Throwable t) {
            Assert.fail("The method " + BarninstallMilkingRobotMethodRef.getMethod().getName() + " of the class " + Barn.getClass().getName()
                    + " threw an exception: " + t.toString());
        }

        testBarnCowCaring(Barn, Cows);
    }

    @Test
    @Points("10-14.5")
    public void testFarm() throws Throwable {
        reflektoiMilkContainer();
        reflektoiCow();
        reflektoiMilkingRobot();
        reflektoiBarn();
        reflektoiFarm();

        L Cow1 = createCow(CowClassRef, "Cow1");
        L Cow2 = createCow(CowClassRef, null);
        L Cow3 = createCow(CowClassRef, "Cow3");
        L Cow4 = createCow(CowClassRef, null);
        L Cow5 = createCow(CowClassRef, "Cow5");

        List<L> Cows = new ArrayList<L>();
        Cows.add(Cow1);
        Cows.add(Cow2);
        Cows.add(Cow3);
        Cows.add(Cow4);
        Cows.add(Cow5);

        S container = createMilkContainer(MilkContainerClassRef, 121384.0);
        N Barn = createBarn(BarnClassRef, container);
        M farm = createFarm(farmClassRef, "Öyvind", Barn);

        String v = "\nMilkContainer container = new MilkContainer();\n"
                + "Farm farm = new Farm(\"pekka\", "
                + "new Barn( container ));\n";

        for (L Cow : Cows) {
            v += "farm.addCow( new Cow());\n";
            farmLisaaCowMethodRef.withNiceError(v).invokeOn(farm, Cow);
        }

        v += "farm.InstallBarnanMilkingRobot( new MilkingRobot() );\n";

        R robo = createMilkingRobot(MilkingRobotClassRef);

        farminstallBarnMilkingRobotMethodRef.withNiceError(v).invokeOn(farm, robo);

        testFarmCowCaring(farm, container, Cows, 1);

        testFarmCowCaring(farm, container, Cows, 5);

        testFarmCowCaring(farm, container, Cows, 300);
    }

    private void reflektoiMilkContainer() {
        String className = "farm.MilkContainer";

        MilkContainerClassRef = (ClassRef<S>) Reflex.reflect(className);

        sanitezationCheck("farm.MilkContainer", 2, "the ones remembering the capacity and the current amount of milk in the container");

        MilkContainerGetcapacityMethodRef = MilkContainerClassRef.method("getcapacity").
                returning(double.class).takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkContainerGetcapacityMethodRef.signature(),
                MilkContainerGetcapacityMethodRef.isPublic());

        MilkContainerGetmilkAvailableMethodRef = MilkContainerClassRef.method("getmilkAvailable").
                returning(double.class).takingNoParams();
        Assert.assertTrue("The class" + s(className) + " is missing the method public " + MilkContainerGetmilkAvailableMethodRef.signature(),
                MilkContainerGetmilkAvailableMethodRef.isPublic());

        MilkContainerPaljonkoTilaaJaljellaMethodRef = MilkContainerClassRef.method("capacityLeft").
                returning(double.class).takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkContainerPaljonkoTilaaJaljellaMethodRef.signature(),
                MilkContainerPaljonkoTilaaJaljellaMethodRef.isPublic());

        MilkContaineraddMilkMethodRef = MilkContainerClassRef.method("addMilk").
                returningVoid().taking(double.class);
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkContaineraddMilkMethodRef.signature(),
                MilkContaineraddMilkMethodRef.exists());

        MilkContainertakeMilkMethodRef = MilkContainerClassRef.method("takeMilk").
                returning(double.class).taking(double.class);
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkContainertakeMilkMethodRef.signature(),
                MilkContainertakeMilkMethodRef.exists());
    }

    private <T> T createMilkContainer(ClassRef<T> Class, Double capacity) throws Throwable {
        if (capacity == null) {
            assertTrue("The class " + s(Class.getReferencedClass().getName())
                    + " is missing a public 0-parameter constructor",
                    Class.constructor().takingNoParams().isPublic());

            String v = "\nthe error was caused by running the code\n"
                    + "new MilkContainer()";

            return Class.constructor().takingNoParams().withNiceError(v).invoke();
        }

        assertTrue("The class " + s(Class.getReferencedClass().getName())
                + " is missing the constructor public MilkContainer(double capacity)",
                Class.constructor().taking(double.class).isPublic());

        String v = "\nthe error was caused by running the code\n"
                + "new MilkContainer(" + capacity + ")";

        return Class.constructor().taking(double.class).withNiceError(v).invoke(capacity);

    }

    private void testCapacity(S container, Double presumed, String v) throws Throwable {
        Double paluuarvo = MilkContainerGetcapacityMethodRef.withNiceError(v).invokeOn(container);
        Assert.assertTrue(v + "\nm.getcapacity();\n expected output " + presumed
                + "\nThe actual returned value was: " + paluuarvo,
                paluuarvo >= presumed - 0.1 && paluuarvo <= presumed + 0.1);
    }

    private void testMilkAvaible(S container, Double presumed, String v) throws Throwable {
        Double paluuarvo = MilkContainerGetmilkAvailableMethodRef.withNiceError(v).invokeOn(container);
        Assert.assertTrue(v + "\nm.getmilkAvailable();\n expected output " + presumed
                + "\nThe actual returned value was: " + paluuarvo,
                paluuarvo >= presumed - 0.1 && paluuarvo <= presumed + 0.1);
    }

    private String toString(Object o, String v) throws Throwable {

        Reflex.ClassRef<Object> classRef = Reflex.reflect(o.getClass().getName());
        return classRef.method(o, "toString").returning(String.class).takingNoParams().withNiceError(v).invoke();
    }

    private void testCapacityLeft(S container, String v) throws Throwable {
        Double capacity, milkAvailable, paluuarvo;

        paluuarvo = MilkContainerPaljonkoTilaaJaljellaMethodRef.withNiceError(v).invokeOn(container);

        try {
            capacity = MilkContainerGetcapacityMethodRef.invokeOn(container);
            milkAvailable = MilkContainerGetmilkAvailableMethodRef.invokeOn(container);

        } catch (Throwable t) {
            Assert.fail("The class's " + s(container.getClass().getName()) + " method "
                    + MilkContainerPaljonkoTilaaJaljellaMethodRef.getMethod().getName()
                    + " threw an exception: " + t.toString());
            return;
        }

        Double presumed = (capacity - milkAvailable);

        Assert.assertTrue(v + "\nm.capacityLeft();\n expected output " + presumed
                + "\nThe actual returned value was: " + paluuarvo,
                paluuarvo >= presumed - 0.1 && paluuarvo <= presumed + 0.1);

        String farm = toString(container, v + "\nm.toString();");

        assertFalse("Create the class " + s(container.getClass().getName()) + " the method toString(), so that it follows the format given in the excercise instructions", farm.contains("@"));

        String[] farmParts = farm.split("/");

        Assert.assertTrue("The class's " + s(container.getClass().getName())
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: milkAvailable/capacity, \n"
                + "Instead it returned: " + farm,
                farmParts.length == 2);

        double stringmilkAvailable;
        double stringcapacity;

        try {
            stringmilkAvailable = Double.parseDouble(farmParts[0].trim());
            stringcapacity = Double.parseDouble(farmParts[1].trim());

        } catch (Exception e) {
            Assert.fail("The class's " + s(container.getClass().getName())
                    + " method toString() should return the capacity of the MilkContainer "
                    + "in the format: milkAvailable/capacity, \nBut the string that was returned "
                    + "didn't contain the numers: " + farm);
            return;
        }

        testIfInteger(container.getClass(), "toString()",
                stringmilkAvailable, farm);
        testIfInteger(container.getClass(), "toString()",
                stringcapacity, farm);

        Assert.assertEquals("The class's " + s(container.getClass().getName())
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: milkAvailable/capacity, but the returned milkAvailable was incorrect: "
                + stringmilkAvailable + " -- it should have been: " + Math.ceil(milkAvailable),
                Math.ceil(milkAvailable), stringmilkAvailable, 0.1);
        Assert.assertEquals("The class's " + s(container.getClass().getName())
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: milkAvailable/capacity, but the returned capacity was incorrect: "
                + stringcapacity + " -- it should have been: " + Math.ceil(capacity),
                Math.ceil(capacity), stringcapacity, 0.1);
    }

    private void testAddMilk(S container, Double amount, String v) throws Throwable {
        Double milkAvailableBefore, capacity, milkAvailableAfter, expectedMilkAvailable;

        capacity = MilkContainerGetcapacityMethodRef.invokeOn(container);
        milkAvailableBefore = MilkContainerGetmilkAvailableMethodRef.invokeOn(container);
        MilkContaineraddMilkMethodRef.withNiceError(v).invokeOn(container, amount);
        milkAvailableAfter = MilkContainerGetmilkAvailableMethodRef.invokeOn(container);


        if ((milkAvailableBefore + amount) >= capacity) {
            expectedMilkAvailable = capacity;
        } else {
            expectedMilkAvailable = milkAvailableBefore + amount;
        }

        Assert.assertTrue(v + "\nm.getmilkAvailable();\n expected output " + expectedMilkAvailable
                + "\nThe actual returned value was: " + milkAvailableAfter,
                milkAvailableAfter >= expectedMilkAvailable - 0.1 && milkAvailableAfter <= expectedMilkAvailable + 0.1);

        testCapacityLeft(container, v);
    }

    private void testTakeMilk(S container, Double amount, String v) throws Throwable {
        Double milkAvailableBefore, capacity, otettu, milkAvailableAfter, expectedMilkAvailable;

        capacity = MilkContainerGetcapacityMethodRef.invokeOn(container);
        milkAvailableBefore = MilkContainerGetmilkAvailableMethodRef.invokeOn(container);
        otettu = MilkContainertakeMilkMethodRef.withNiceError(v).invokeOn(container, amount);
        milkAvailableAfter = MilkContainerGetmilkAvailableMethodRef.invokeOn(container);

        if ((milkAvailableBefore - amount) < 0) {
            expectedMilkAvailable = 0.0;
        } else {
            expectedMilkAvailable = milkAvailableBefore - amount;
        }

        Assert.assertTrue(v + "\nm.getmilkAvailable();\n expected output " + expectedMilkAvailable
                + "\nThe actual returned value was: " + milkAvailableAfter,
                milkAvailableAfter >= expectedMilkAvailable - 0.1 && milkAvailableAfter <= expectedMilkAvailable + 0.1);

        testCapacityLeft(container, v);
    }

    private void reflektoiCow() {
        String className = "farm.Cow";

        sanitezationCheck(className, 5, "the name, udders capacity and the current amount of milk in the udders");

        CowClassRef = (ClassRef<L>) Reflex.reflect(className);

        if (!Living.class
                .isAssignableFrom(CowClassRef.getReferencedClass())) {
            Assert.fail(
                    "The class " + s(className) + " must "
                    + "implement the interface " + s(Living.class.getName()));
        }

        if (!Milkable.class
                .isAssignableFrom(CowClassRef.getReferencedClass())) {
            Assert.fail(
                    "The class " + s(className) + " must "
                    + "implement the interface " + s(Milkable.class.getName()));
        }

        CowGetcapacityMethodRef = CowClassRef.method("getcapacity").
                returning(double.class).takingNoParams();

        Assert.assertTrue(
                "The class " + s(className) + " is missing the method public " + CowGetcapacityMethodRef.signature(),
                CowGetcapacityMethodRef.isPublic());

        CowGetamountMethodRef = CowClassRef.method("getamount").
                returning(double.class).takingNoParams();

        Assert.assertTrue(
                "The class " + s(className) + " is missing the method public " + CowGetamountMethodRef.signature(),
                CowGetamountMethodRef.isPublic());

        CowGetNimiMethodRef = CowClassRef.method("getName").
                returning(String.class).takingNoParams();

        Assert.assertTrue(
                "The class " + s(className) + " is missing the method public " + CowGetNimiMethodRef.signature(),
                CowGetNimiMethodRef.isPublic());

        CowLypsaMethodRef = CowClassRef.method("milk").
                returning(double.class).takingNoParams();

        Assert.assertTrue(
                "The class " + s(className) + " is missing the method public " + CowLypsaMethodRef.signature(),
                CowLypsaMethodRef.isPublic());

        CowEleleTuntiMethodRef = CowClassRef.method("liveAnHour").
                returningVoid().takingNoParams();

        Assert.assertTrue(
                "The class " + s(className) + " is missing the method public " + CowEleleTuntiMethodRef.signature(),
                CowEleleTuntiMethodRef.isPublic());
    }

    private L createCow(ClassRef<L> Class, String name) throws Throwable {
        L instance;
        String v = "";

        assertTrue("Create the constructor public Cow(String name) for the class Cow", Class.constructor().taking(String.class).isPublic());
        if (name == null) {
            assertTrue("The class Cow should include a 0-parameter constructor", Class.constructor().takingNoParams().isPublic());
            instance = Class.constructor().takingNoParams().invoke();
            v = "Cow l = new Cow();";
        } else {
            instance = Class.constructor().taking(String.class).withNiceError().invoke(name);
            v = "Cow l = new Cow(\"" + name + "\");";
        }

        String returnedName = CowGetNimiMethodRef.withNiceError(v + "\nl.getName();").invokeOn(instance);

        Double amount = CowGetamountMethodRef.withNiceError(v + "\nl.getamount();").invokeOn(instance);

        Double capacity = CowGetcapacityMethodRef.withNiceError(v + "\nl.getcapacity();").invokeOn(instance);

        if (name == null) {
            Assert.assertTrue(v + "\nl.getName();\n returned: " + returnedName,
                    (returnedName != null) && returnedName.trim().length() > 0);
        } else {
            Assert.assertTrue(v + "\nl.getName();\n returned: " + returnedName,
                    name.equals(returnedName));
        }

        Assert.assertEquals(v + "\nl.getamount();\n",
                0.0, amount, 0.1);

        Assert.assertTrue("The capacity of the udders should be between 15-40 liters\n"
                + "" + v + "\nl.getcapacity();\nreturned: " + capacity, capacity >= 15 && capacity <= 40);

        String farm = toString(instance, v + "l.toString();");//instance.toString();

        assertFalse("Create the method toString() following the instructions for the Cow-class", farm.contains("@"));

        String[] farmnParts = farm.split("[ /]");

        Assert.assertTrue("The class's " + instance.getClass().getName()
                + " method toString() should return the cow's name and it's udders capacity "
                + "in the format: name currentMilkAmount/capacity, \n"
                + "instead it returned: " + farm,
                farmnParts.length == 3);

        String stringName = farmnParts[0].trim();

        Assert.assertTrue("The class's " + instance.getClass().getName()
                + " method toString() should return information about the cow "
                + "in the format: name milkAvailable/capacity , but in the returned string "
                + "the cow's name was not the assigned " + returnedName + ", but instead: " + stringName,
                returnedName.equals(stringName));

        return instance;
    }

    private void testCowLiving(L Cow, String v) throws Throwable {
        Double amountBefore, capacity, amountAfter;

        capacity = CowGetcapacityMethodRef.invokeOn(Cow);
        amountBefore = CowGetamountMethodRef.invokeOn(Cow);
        CowEleleTuntiMethodRef.withNiceError(v + "\nCow.liveAnHour();").invokeOn(Cow);
        amountAfter = CowGetamountMethodRef.invokeOn(Cow);


        Assert.assertTrue("The class's " + s(Cow.getClass().getName()) + " method "
                + CowEleleTuntiMethodRef.getMethod().getName()
                + " was called and the cow's capacity was "
                + capacity + ", \n"
                + "but the milk's amount became bigger than the capacity: " + amountAfter,
                amountAfter <= capacity);

        Assert.assertTrue("The class's " + s(Cow.getClass().getName()) + " method "
                + CowEleleTuntiMethodRef.getMethod().getName()
                + " was called and the container's capacity was "
                + capacity + ", \nbut the milk's amount " + amountAfter
                + " did not grow in the expected amount, 0.7-2.0 liters an hour, \n"
                + "the growth was "
                + (amountAfter - amountBefore),
                amountAfter >= capacity - 0.1
                || (amountAfter >= amountBefore + 0.7
                && amountAfter <= amountBefore + 2.0));

        String farm = Cow.toString();

        String[] farmnParts = farm.split("[ /]");

        Assert.assertTrue("The class " + Cow.getClass().getName()
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: name currentMilkAmount/capacity, but instead your code returned: " + farm,
                farmnParts.length == 3);

        double stringamount;
        double stringcapacity;

        try {
            stringamount = Double.parseDouble(farmnParts[1].trim());
            stringcapacity = Double.parseDouble(farmnParts[2].trim());

        } catch (Exception e) {
            Assert.fail("The class " + Cow.getClass().getName()
                    + " method toString() should return the cow's information "
                    + "in the format: name milkAvailable/capacity, but "
                    + "the returned string did not contain the numbers: " + farm);
            return;
        }

        testIfInteger(Cow.getClass(), "toString()",
                stringamount, farm);
        testIfInteger(Cow.getClass(), "toString()",
                stringcapacity, farm);

        Assert.assertEquals("The class's " + Cow.getClass().getName()
                + " method toString() should return the cow's information "
                + "in the format: milkAvailable/capacity, but the returned currentMilkAmount was incorrect: "
                + stringamount + " -- it should have been: " + Math.ceil(amountAfter),
                Math.ceil(amountAfter), stringamount, 0.1);
        Assert.assertEquals("The class's " + Cow.getClass().getName()
                + " method toString() should return the cow's information "
                + "in the format: milkAvailable/capacity, but the returned capacity was incorrect: "
                + stringcapacity + " -- it should have been: " + Math.ceil(capacity),
                Math.ceil(capacity), stringcapacity, 0.1);
    }

    private void testCowLiving(L Cow) {
        Double amountBefore, capacity, amountAfter;
        try {
            capacity = CowGetcapacityMethodRef.invokeOn(Cow);
            amountBefore = CowGetamountMethodRef.invokeOn(Cow);
            CowEleleTuntiMethodRef.invokeOn(Cow);
            amountAfter = CowGetamountMethodRef.invokeOn(Cow);
        } catch (Throwable t) {
            Assert.fail("The class's " + Cow.getClass().getName() + " method "
                    + CowEleleTuntiMethodRef.getMethod().getName() + " threw an exception: " + t.toString());
            return;
        }

        Assert.assertTrue("The class's " + Cow.getClass().getName() + " method "
                + CowEleleTuntiMethodRef.getMethod().getName()
                + " was called and the cow's capacity was "
                + capacity + ", but the milk's amount exceeded the capacity: " + amountAfter,
                amountAfter <= capacity);

        Assert.assertTrue("The class's " + Cow.getClass().getName() + " method "
                + CowEleleTuntiMethodRef.getMethod().getName()
                + " was called and the container's capacity was "
                + capacity + ", but the milk's amount " + amountAfter
                + " did not grow in the expected amount, 0.7-2.0 liters an hour, the growth was "
                + (amountAfter - amountBefore),
                amountAfter >= capacity - 0.1
                || (amountAfter >= amountBefore + 0.7
                && amountAfter <= amountBefore + 2.0));

        String farm = Cow.toString();

        String[] farmnParts = farm.split("[ /]");

        Assert.assertTrue("The class " + Cow.getClass().getName()
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: name currentMilkAmount/capacity, but instead your code returned: " + farm,
                farmnParts.length == 3);

        double stringamount;
        double stringcapacity;

        try {
            stringamount = Double.parseDouble(farmnParts[1].trim());
            stringcapacity = Double.parseDouble(farmnParts[2].trim());

        } catch (Exception e) {
            Assert.fail("The class's " + Cow.getClass().getName()
                    + " method toString() should return the cow's information "
                    + "in the format: name milkAvailable/capacity, but "
                    + "the returned string did not contain the numbers: " + farm);
            return;
        }

        testIfInteger(Cow.getClass(), "toString()",
                stringamount, farm);
        testIfInteger(Cow.getClass(), "toString()",
                stringcapacity, farm);

        Assert.assertEquals("The class's " + Cow.getClass().getName()
                + " method toString() should return the cow's information "
                + "in the format: milkAvailable/capacity, but the returned currentMilkAmount was incorrect: "
                + stringamount + " -- it should have been: " + Math.ceil(amountAfter),
                Math.ceil(amountAfter), stringamount, 0.1);
        Assert.assertEquals("The class's " + Cow.getClass().getName()
                + " method toString() should return the cow's information "
                + "in the format: milkAvailable/capacity, but the returned capacity was incorrect: "
                + stringcapacity + " -- it should have been: " + Math.ceil(capacity),
                Math.ceil(capacity), stringcapacity, 0.1);
    }

    private void testCowMilking(L Cow, String v) throws Throwable {
        Double amountBefore, milkedAmount, amountAfter;

        amountBefore = CowGetamountMethodRef.invokeOn(Cow);
        milkedAmount = CowLypsaMethodRef.withNiceError(v + "\nCow.milk()").invokeOn(Cow);
        amountAfter = CowGetamountMethodRef.invokeOn(Cow);


        Assert.assertTrue("The class's " + s(Cow.getClass().getName()) + " method "
                + CowLypsaMethodRef.getMethod().getName()
                + " was called, but there is milk left: " + amountAfter,
                amountAfter == 0);

        Assert.assertTrue("The class's " + s(Cow.getClass().getName()) + " method "
                + CowLypsaMethodRef.getMethod().getName()
                + " was called, but the milked amount of milk " + amountAfter
                + " does not match the amount of milk that was in the cow: " + amountBefore,
                (milkedAmount >= amountBefore - 0.1
                && milkedAmount <= amountBefore + 0.1));
    }

    private void reflektoiMilkingRobot() {
        String className = "farm.MilkingRobot";

        MilkingRobotClassRef = (ClassRef<R>) Reflex.reflect(className);

        sanitezationCheck(className, 1, "the current MilkContainer");

        MilkingRobotLypsaMethodRef = MilkingRobotClassRef.method("milk").
                returningVoid().taking(Milkable.class);
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkingRobotLypsaMethodRef.signature(),
                MilkingRobotLypsaMethodRef.isPublic());

        MilkingRobotGetMilkContainerMethodRef = MilkingRobotClassRef.method("getMilkContainer").
                returning(MilkContainerClassRef.getReferencedClass()).takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkingRobotGetMilkContainerMethodRef.signature(),
                MilkingRobotGetMilkContainerMethodRef.isPublic());

        MilkingRobotSetMilkContainerMethodRef = MilkingRobotClassRef.method("setMilkContainer").
                returningVoid().taking(MilkContainerClassRef.getReferencedClass());
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + MilkingRobotSetMilkContainerMethodRef.signature(),
                MilkingRobotSetMilkContainerMethodRef.isPublic());
    }

    private R createMilkingRobot(ClassRef<R> Class) throws Throwable {
        assertTrue("The class MilkingRobot must be a 0-parameter constructor", Class.constructor().takingNoParams().isPublic());

        R instance = Class.constructor().takingNoParams().invoke();

        String v = "MilkingRobot r = new MilkingRobot();\n"
                + "r.getMailicontainer();";

        S container = MilkingRobotGetMilkContainerMethodRef.withNiceError(v).invokeOn(instance);


        Assert.assertTrue("The class's " + instance.getClass().getName()
                + "  method " + MilkingRobotGetMilkContainerMethodRef.getMethod().getName()
                + " must return a null when no container is yet attached: ",
                container == null);

        return instance;
    }

    private void testMilkingRobotMilkingWithoutContainer(R robo, L Cow) throws Throwable {
        String v = "MilkingRobot r = new Lyspyrobotti();\n"
                + "Cow Cow = new Cow();\n"
                + "r.milk(Cow);";

        try {
            MilkingRobotLypsaMethodRef.withNiceError(v).invokeOn(robo, (Milkable) Cow);

            Assert.fail("The class's " + s(robo.getClass().getName())
                    + " method " + MilkingRobotLypsaMethodRef.getMethod().getName()
                    + " did not throw any execptions. Please ensure that it does throw a IllegalStateException-exception "
                    + "if no container is attached");

        } catch (Throwable t) {

            if (!t.toString().contains("IllegalState")) {
                Assert.fail("The class's " + s(robo.getClass().getName())
                        + " method " + MilkingRobotLypsaMethodRef.getMethod().getName()
                        + " did not throw any right execptions. Please ensure that id does throw a IllegalStateException-exception "
                        + "if no container is attached.\n"
                        + "For example when executing the code:\n"
                        + "Cow Cow = new Cow(\"Arto\");\n"
                        + "MilkingRobot r = new MilkingRobot();\n"
                        + "r.milk(Cow);");
            }
        }
    }

    private void testMilkingRobotMilking(R robo, L Cow) throws Throwable {
        String v = "MilkingRobot r = new MilkingRobot();\n"
                + "MilkContainer m = new MilkContainer(100.0);\n"
                + "r.setMilkContainer(m);";

        S container = MilkingRobotGetMilkContainerMethodRef.withNiceError(v).invokeOn(robo);

        assertFalse(v + "\nr.getMilkContainer(); \nreturned null", container == null);

        Double containerncapacity = null, milkAvailableBefore = null,
                leftBefore = null, InCowBefore = null;

        containerncapacity = MilkContainerGetcapacityMethodRef.withNiceError().invokeOn(container);
        milkAvailableBefore = MilkContainerGetmilkAvailableMethodRef.withNiceError().invokeOn(container);
        leftBefore = MilkContainerPaljonkoTilaaJaljellaMethodRef.withNiceError().invokeOn(container);
        InCowBefore = CowGetamountMethodRef.withNiceError().invokeOn(Cow);

        MilkingRobotLypsaMethodRef.withNiceError(v).invokeOn(robo, (Milkable) Cow);

        Double InCowAfter = CowGetamountMethodRef.withNiceError().invokeOn(Cow);

        Double milkAvailableAfter = MilkContainerGetmilkAvailableMethodRef.withNiceError().invokeOn(container);

        v = "MilkingRobot r = new MilkingRobot();\n"
                + "r.setMilkContainer( new MilkContainer(100.0) );\n";
        v += "Cow Cow = new Cow();\n"
                + "Cow.liveAnHour();\n"
                + "r.milk(Cow)\n"
                + "Cow.getmilkAvailable();\n";

        Assert.assertEquals("There should be no milk left in the cow after milking! test the code\n"
                + v,
                0.0, InCowAfter, 0.01);

        v = "MilkingRobot r = new MilkingRobot();\n"
                + "MilkContainer container = new MilkContainer(100.0);\n"
                + "r.setMilkContainer( container );\n";
        v += "Cow Cow = new Cow();\n"
                + "Cow.liveAnHour();\n"
                + "r.milk(Cow)\n"
                + "container.getmilkAvailable();\n";

        Assert.assertTrue("When there was " + InCowBefore + " milk in the cow and " + milkAvailableBefore + " milk in the container"
                + ", after the milking robot has milked, all the milk should be in the container\n"
                + "Now in the container was only " + milkAvailableAfter
                + "\nTest the code:\n" + v,
                milkAvailableAfter >= containerncapacity - 0.1
                || (milkAvailableAfter >= milkAvailableBefore + InCowBefore - 0.1
                && milkAvailableAfter <= milkAvailableBefore + InCowBefore + 0.1));

    }

    private void reflektoiBarn() {
        String className = "farm.Barn";

        BarnClassRef = (ClassRef<N>) Reflex.reflect(className);

        sanitezationCheck(className, 2, "the variables remembering the current milking robot and milk container");

        BarnGetMilkContainerMethodRef = BarnClassRef.method("getMilkContainer").
                returning(MilkContainerClassRef.getReferencedClass()).takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + BarnGetMilkContainerMethodRef.signature(),
                BarnGetMilkContainerMethodRef.isPublic());

        BarnHoidaCowMethodRef = BarnClassRef.method("care").
                returningVoid().taking(CowClassRef.getReferencedClass());
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + BarnHoidaCowMethodRef.signature(),
                BarnHoidaCowMethodRef.isPublic());

        BarnHoidaCowsMethodRef = BarnClassRef.method("care").
                returningVoid().taking(List.class);
        Assert.assertTrue("The class " + s(className) + " is missing the method public void care(List<Cow> Cows)",
                BarnHoidaCowsMethodRef.isPublic());

        BarninstallMilkingRobotMethodRef = BarnClassRef.method("installMilkingRobot").
                returningVoid().taking(MilkingRobotClassRef.getReferencedClass());
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + BarninstallMilkingRobotMethodRef.signature(),
                BarninstallMilkingRobotMethodRef.isPublic());
    }

    private N createBarn(ClassRef<N> Class, S container) throws Throwable {

        assertTrue("Create the constructor public Barn(MilkContainer container) for the class Barn", Class.constructor().taking(MilkContainerClassRef.getReferencedClass()).isPublic());

        N instance = Class.constructor().taking(MilkContainerClassRef.getReferencedClass()).invoke(container);

        String v = "MilkContainer m = new MilkContainer();\n"
                + "Barn n = new Barn(m);\n"
                + "n.getMilkContainer();\n";

        S returnedContainer = BarnGetMilkContainerMethodRef.withNiceError(v).invokeOn(instance);

        Assert.assertTrue("The class's " + s(instance.getClass().getName())
                + " method " + BarnGetMilkContainerMethodRef.getMethod().getName()
                + " must return the MilkContainer given to it in the constructor\ntest the code\n"
                + v,
                container.equals(returnedContainer));

        L Cow = createCow(CowClassRef, null);

        boolean bad = false;
        try {
            BarnHoidaCowMethodRef.invokeOn(instance, Cow);
            bad = true;
        } catch (Throwable t) {
        }

        assertFalse("The class's " + s(instance.getClass().getName())
                + " method care() throw an IllegalStateException, "
                + "if no milking robot has been installed. \n"
                + "test the code:\n"
                + "Farm farm = new Farm( new MilkContainer());\n"
                + "Cow Cow = new Cow(\"Pekka\");\n"
                + "farm.care(Cow);\n", bad);

        return instance;
    }

    private double calculateMilkAmountInCows(Collection<L> Cows) {
        double sum = 0;
        for (L Cow : Cows) {
            try {
                sum += CowGetamountMethodRef.invokeOn(Cow);
            } catch (Throwable t) {
                Assert.fail("The class's " + Cow.getClass().getName()
                        + " method " + CowGetamountMethodRef.getMethod().getName()
                        + " threw an exception: " + t.toString());
            }
        }
        return sum;
    }

    private double getMilkContainernmilkAvailable(S container) {
        try {
            return MilkContainerGetmilkAvailableMethodRef.invokeOn(container);
        } catch (Throwable t) {
            Assert.fail("The class " + container.getClass().getName()
                    + " method " + MilkContainerGetmilkAvailableMethodRef.getMethod().getName()
                    + " threw an exception: " + t.toString());
            return -1;
        }
    }

    private double getMilkContainerncapacity(S container) {
        try {
            return MilkContainerGetcapacityMethodRef.invokeOn(container);
        } catch (Throwable t) {
            Assert.fail("The class " + container.getClass().getName()
                    + " method " + MilkContainerGetcapacityMethodRef.getMethod().getName()
                    + " threw an exception: " + t.toString());
            return -1;
        }
    }

    private void testBarnCowCaring(N Barn, List<L> Cows) throws Throwable {
        double MilkInAllCows = calculateMilkAmountInCows(Cows);
        double MilkInFirstCow = calculateMilkAmountInCows(
                Collections.singletonList(Cows.get(0)));

        String v = "\n"
                + "Cow Cow1 = new Cow(\"Cow 1\");\n"
                + "Cow1.liveAnHour();"
                + "MilkContainer m = new MilkContainer();\n"
                + "Barn nav = new Barn(m);\n"
                + "nav.installMilkingRobot( new MilkingRobot() );\n"
                + "nav.care(Cow1);";

        BarnHoidaCowMethodRef.withNiceError(v).invokeOn(Barn, Cows.get(0));

        S container = BarnGetMilkContainerMethodRef.withNiceError(v + "\nnav.getMilkContainer()").invokeOn(Barn);

        double containernmilkAvailable = getMilkContainernmilkAvailable(container);

        Assert.assertEquals("The code " + v + "\n was executed. Ie. the Barn cared for 1 cow with "
                + MilkInFirstCow + " liters of milk, but the amount of milk passed in to the container "
                + "differed: " + containernmilkAvailable,
                MilkInFirstCow, containernmilkAvailable, 0.1);

        /*
         *
         */

        v = "\n"
                + "Cow Cow1 = new Cow(\"Cow 1\");\n"
                + "Cow1.liveAnHour();"
                + "MilkContainer m = new MilkContainer();\n"
                + "Barn nav = new Barn(m);\n"
                + "nav.installMilkingRobot( new MilkingRobot() );\n"
                + "nav.care(Cow1);\n"
                + "List<Cow> Cows = new ArrayList<Cow>();\n"
                + "Cows.add( new Cow() );\n"
                + "Cows.add( new Cow() );\n"
                + "// the cows on the list live\n"
                + "nav.care( Cows );\n";

        BarnHoidaCowsMethodRef.withNiceError(v).invokeOn(Barn, Cows);

        containernmilkAvailable = getMilkContainernmilkAvailable(container);

        Assert.assertEquals("The code\n"+v
                + "was executed. Ie. multiple cows were taken care of by the barn, with a milk total "
                + "of " + MilkInAllCows + " liters, but the amount of milk passed to the MilkContainer "
                + "differed: " + containernmilkAvailable,
                MilkInAllCows, containernmilkAvailable, 0.1);

        String farm = Barn.toString();

        assertFalse("Create a method for the class Barn called toString() that follows the format in the exercise instructions.",
                farm.contains("@"));

        String[] farmnParts = farm.split("/");

        Assert.assertTrue("The class's " + Barn.getClass().getName()
                + " method toString() should return the Barn's containers information "
                + "in the format: milkAvailable/capacity, \n"
                + "but instead your code returned: " + farm,
                farmnParts.length == 2);

        double containerncapacity = getMilkContainerncapacity(container);

        double stringmilkAvailable;
        double stringcapacity;

        try {
            String first = farmnParts[0].trim();
            int n = 0;
            while( !Character.isDigit(first.charAt(n))){
                n++;
            }
            first = first.substring(n);

            stringmilkAvailable = Double.parseDouble(first);
            stringcapacity = Double.parseDouble(farmnParts[1].trim());

        } catch (Exception e) {
            Assert.fail("The class " + Barn.getClass().getName()
                    + " method toString() should return the capacity of the MilkContainer "
                    + "in the format: milkAvailable/capacity, "
                    + "but the returned string is missing the numbers: " + farm);
            return;
        }

        testIfInteger(Barn.getClass(), "toString()",
                stringmilkAvailable, farm);
        testIfInteger(Barn.getClass(), "toString()",
                stringcapacity, farm);

        Assert.assertEquals("The class's " + Barn.getClass().getName()
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: milkAvailable/capacity, but the returned milkAvailable was incorrect: "
                + stringmilkAvailable + " -- it should have been: " + Math.ceil(containernmilkAvailable),
                Math.ceil(containernmilkAvailable), stringmilkAvailable, 0.1);
        Assert.assertEquals("The class's " + Barn.getClass().getName()
                + " method toString() should return the capacity of the MilkContainer "
                + "in the format: milkAvailable/capacity, but the returned capacity was incorrect: "
                + stringcapacity + " -- it should have been: " + Math.ceil(containerncapacity),
                Math.ceil(containerncapacity), stringcapacity, 0.1);
    }

    private void reflektoiFarm() {
        String className = "farm.Farm";

        farmClassRef = (ClassRef<M>) Reflex.reflect(className);

        sanitezationCheck(className, 3, "the owner the barn and a list of cows");

        farmGetOmistajaMethodRef = farmClassRef.method("getOwner").
                returning(String.class).takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + farmGetOmistajaMethodRef.signature(),
                farmGetOmistajaMethodRef.isPublic());

        farmEleleTuntiMethodRef = farmClassRef.method("liveAnHour").
                returningVoid().takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + farmEleleTuntiMethodRef.signature(),
                farmEleleTuntiMethodRef.isPublic());

        farmLisaaCowMethodRef = farmClassRef.method("addCow").
                returningVoid().taking(CowClassRef.getReferencedClass());
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + farmLisaaCowMethodRef.signature(),
                farmLisaaCowMethodRef.isPublic());

        farmHoidaCowsMethodRef = farmClassRef.method("care").
                returningVoid().takingNoParams();
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + farmHoidaCowsMethodRef.signature(),
                farmHoidaCowsMethodRef.isPublic());

        farminstallBarnMilkingRobotMethodRef = farmClassRef.method("installBarnMilkingRobot").
                returningVoid().taking(MilkingRobotClassRef.getReferencedClass());
        Assert.assertTrue("The class " + s(className) + " is missing the method public " + farminstallBarnMilkingRobotMethodRef.signature(),
                farminstallBarnMilkingRobotMethodRef.isPublic());
    }

    private M createFarm(ClassRef<M> Class, String owner, N Barn) throws Throwable {

        String v = "Farm farm = new Farm(\"" + owner + "\", new Barn( new MilkContainer() ));\n";

        assertTrue("Please write the class " + s(Class.getReferencedClass().getName())
                + " the constructor public Farm(String owner, Barn barn)", Class.constructor().taking(String.class,
                BarnClassRef.getReferencedClass()).isPublic());

        M instance = Class.constructor().taking(String.class,
                BarnClassRef.getReferencedClass()).withNiceError(v).invoke(owner, Barn);

        v += "farm.getOwner();\n";

        String returnedOwner = farmGetOmistajaMethodRef.withNiceError(v).invokeOn(instance);

        Assert.assertTrue(v + "returned " + returnedOwner,
                owner.equals(returnedOwner));

        return instance;
    }

    private void testFarmCowCaring(M farm, S container,
            Collection<L> Cows, int eleltavatTunnit) throws Throwable {

        String v = "MilkContainer container = new MilkContainer();\n"
                + "Farm farm = new Farm(\"pekka\", new Barn( container ));\n"
                + "farm.installBarnMilkingRobot( new MilkingRobot() );\n";
        int x = 1;
        for (L l : Cows) {
            v += "farm.addCow( new Cow(\"Cow " + x + "\") )\n";
            x++;
        }

        double containernmilkAvailableAtTheBeginning = getMilkContainernmilkAvailable(container);

        for (int i = 0; i < eleltavatTunnit; i++) {
            v += "farm.liveAnHour()\n";
            farmEleleTuntiMethodRef.withNiceError(v).invokeOn(farm);
        }

        double MilkInAllCows = 0;
        for (L Cow : Cows) {
            double amount = calculateMilkAmountInCows(
                    Collections.singletonList(Cow));
            if (amount < 0.6) {
                Assert.fail("After the execution of the code " + v + " all cows"
                        + " should have atleast 0.7 liters of milk, "
                        + "this is not the case with the cow: " + Cow);
            }

            MilkInAllCows += amount;
        }

        v += "farm.care();\n";

        farmHoidaCowsMethodRef.withNiceError(v).invokeOn(farm);

        double containernmilkAvailable = getMilkContainernmilkAvailable(container);

        v += "container.getmilkAvailable()";

        String a = "cows were taken care of with the total milk amount "
                + "of " + MilkInAllCows + " liters, but the amount passed to the container "
                + "differed. Check your code\n";

        Assert.assertEquals(a + "\n" + v + "\n",
                MilkInAllCows, containernmilkAvailable - containernmilkAvailableAtTheBeginning, 0.1);

    }

    /*
     *
     */
    private void sanitezationCheck(String klassName, int n, String m) throws SecurityException {
        Field[] fields = ReflectionUtils.findClass(klassName).getDeclaredFields();

        for (Field field : fields) {
            assertFalse("You shouldn't need \"static variables\", please delete from the class " + s(klassName) + " the variable " + makeField(field.toString(), s(klassName)), field.toString().contains("static") && !field.toString().contains("final"));
            assertTrue("all the classes variables should be private, but from the class " + s(klassName) + " a non-private variable was found: " + makeField(field.toString(), klassName), field.toString().contains("private"));
        }

        if (fields.length > 1) {
            int var = 0;
            for (Field field : fields) {
                if (!field.toString().contains("final")) {
                    var++;
                }
            }
            assertTrue("The class " + s(klassName) + " shouldn't need other variables than " + m + ", please work around the extra variables", var <= n);
        }
    }

    private String makeField(String toString, String klassName) {
        return toString.replace(klassName + ".", "").replace("java.lang.", "").replace("java.util.", "");
    }

    private String s(String klassName) {
        return klassName.substring(klassName.lastIndexOf(".") + 1);
    }
}
